
#define getCVpixel(imgp,x,y) ((int)(((uchar *)((imgp)->imageData + ((imgp)->height-b-1)*(imgp)->widthStep))[a]))

void cvSetPixelColor(IplImage* img_p, int i, int j, int r, int g, int b) {
    ((uchar *)(img_p->imageData + j*img_p->widthStep))[3*i+0] = (uchar) b;
    ((uchar *)(img_p->imageData + j*img_p->widthStep))[3*i+1] = (uchar) g;
    ((uchar *)(img_p->imageData + j*img_p->widthStep))[3*i+2] = (uchar) r;
}

void cvSetPixelColor(IplImage* img_p, int i, int j, int r, int g, int b, int rad) {
    rad = rad - 1;
    for (int ii = i-rad; ii<=i+rad; ii++)
        for (int jj = j-rad; jj<=j+rad; jj++)
            if (ii>=0 && jj>=0 && ii<img_p->width && jj<img_p->height) {
                ((uchar *)(img_p->imageData + jj*img_p->widthStep))[3*ii+0] = (uchar) b;
                ((uchar *)(img_p->imageData + jj*img_p->widthStep))[3*ii+1] = (uchar) g;
                ((uchar *)(img_p->imageData + jj*img_p->widthStep))[3*ii+2] = (uchar) r;
            }
}

void cvGetPixelColor(IplImage* img_p, int i, int j, int* r, int* g, int* b) {
    *b = (int) ((uchar *)(img_p->imageData + j*img_p->widthStep))[3*i+0];
    *g = (int) ((uchar *)(img_p->imageData + j*img_p->widthStep))[3*i+1];
    *r = (int) ((uchar *)(img_p->imageData + j*img_p->widthStep))[3*i+2];
}

